## com.saxonica.extra
Class SequenceExchanger.Consumer

    java.lang.Object
      com.saxonica.extra.SequenceExchanger.Consumer

All Implemented Interfaces:
  SequenceIterator

Enclosing class:
  SequenceExchanger

    public static class SequenceExchanger.Consumer

extends java.lang.Object
implements SequenceIterator

The Consumer is a SequenceIterator that reads a sequence of items from the Conduit: that is, it allows its caller to make a sequence of calls on next(), each of which will return the next item pushed onto the Conduit by the corresponding Producer.

Field Summary

Fields inherited from interface net.sf.saxon.om.SequenceIterator
`GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

Constructor Summary
`SequenceExchanger.Consumer(com.saxonica.extra.Conduit conduit, SequenceExchanger.Producer producer)` Create a consumer

Method Summary
`void` `close()` Close the iterator.
`Item` `current()` Get the current value in the sequence (the one returned by the most recent call on next()).
`SequenceIterator` `getAnother()` Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.
`int` `getProperties()` Get properties of this iterator, as a bit-significant integer.
`Item` `next()` Get the next item in the sequence.
`int` `position()` Get the current position.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SequenceExchanger.Consumer

    public SequenceExchanger.Consumer(com.saxonica.extra.Conduit conduit,
                                      SequenceExchanger.Producer producer)

  Create a consumer

  Parameters:
    `conduit` - The conduit from which items are to be read
    `producer` - The producer supplying items to the conduit. This is needed in case the sequence needs to be re-read, which can happen when calling last().

Method Detail

### current

    public Item current()

  Get the current value in the sequence (the one returned by the most recent call on next()). This will be null before the first call of next(). This method does not change the state of the iterator.

  Specified by:
    `current` in interface `SequenceIterator`
  Returns:
    the current item, the one most recently returned by a call on next(). Returns null if next() has not been called, or if the end of the sequence has been reached.
  Since:
    8.4

### getAnother

    public SequenceIterator getAnother()
                                throws XPathException

  Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.

  This method allows access to all the items in the sequence without disturbing the current position of the iterator. Internally, its main use is in evaluating the last() function.

  This method does not change the state of the iterator.

  Specified by:
    `getAnother` in interface `SequenceIterator`
  Returns:
    a SequenceIterator that iterates over the same items, positioned before the first item
  Throws:
    `XPathException` - if any error occurs
  Since:
    8.4

### getProperties

    public int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Specified by:
    `getProperties` in interface `SequenceIterator`
  Returns:
    the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED` and `SequenceIterator.LAST_POSITION_FINDER`. It is always acceptable to return the value zero, indicating that there are no known special properties.

### next

    public Item next()
              throws XPathException

  Get the next item in the sequence. This method changes the state of the iterator, in particular it affects the result of subsequent calls of position() and current().

  Specified by:
    `next` in interface `SequenceIterator`
  Returns:
    the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
  Throws:
    `XPathException` - if an error occurs retrieving the next item
  Since:
    8.4

### position

    public int position()

  Get the current position. This will usually be zero before the first call on next(), otherwise it will be the number of times that next() has been called. Once next() has returned null, the preferred action is for subsequent calls on position() to return -1, but not all existing implementations follow this practice. (In particular, the EmptyIterator is stateless, and always returns 0 as the value of position(), whether or not next() has been called.)

  This method does not change the state of the iterator.

  Specified by:
    `position` in interface `SequenceIterator`
  Returns:
    the current position, the position of the item returned by the most recent call of next(). This is 1 after next() has been successfully called once, 2 after it has been called twice, and so on. If next() has never been called, the method returns zero. If the end of the sequence has been reached, the value returned will always be <= 0; the preferred value is -1.
  Since:
    8.4

### close

    public void close()

  Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

  Specified by:
    `close` in interface `SequenceIterator`

Copyright (c) Saxonica Limited. All rights reserved.